Get a list of Deployments
GET /api
Also reachable at /api, /api.
Lists all of the Deployments in the supplied Space. The results will be sorted from most recent to least recent deployment.
Path Parameters
spaceIdstring (required)
ID of the Space to which the Deployments belong.
Query Parameters
channelsarray of string
Channel Ids to filter results to only Deployments with the given Channel Ids.environmentsarray of string
Environment Ids to filter results to only Deployments with the given Environment Ids.idsarray of string
Deployment Ids to filter results to only Deployments with the given Ids.partialNamestring
A partial name, to limit the set of Deployments to those with a name that includes the partial name.projectsarray of string
Project Ids to filter results to only Deployments with the given Project Ids.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.taskStateenum
Task State to filter results to only Deployments with the given Task State.
Allowed values:Queued,Executing,Failed,Canceled,TimedOut,Success,Cancelling.tenantsarray of string
Tenant Ids to filter results to only Deployments with the given Tenant Ids.
Response
200 — The requested Deployments
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectChangeRequestSettingsarray of objectChangesarray of objectChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectFailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstringSkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectUseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"ChangeRequestSettings": [
{}
],
"Changes": [
{}
],
"ChangesMarkdown": "string",
"ChannelId": "string",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "string",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "string",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "string",
"SkipActions": [
"string"
],
"SpaceId": "string",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "string",
"TenantId": "string",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Create a Deployment
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Request Body
ChangeRequestSettingsarray of objectTypeenum
Allowed values:ServiceNow,JiraServiceManagement.
Changesarray of objectBuildInformationarray of objectCommitsarray of object
Aggregate of distinct commits from all VersionMetadata.ReleaseNotesstringVersionstringWorkItemsarray of object
Aggregate of distinct work items from all VersionMetadata.
ChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstring (required)ExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectStepsarray of object (required)
FailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstring (required)SkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectQuantityToKeepintegerShouldKeepForeverbooleanStrategystringUnitenum
Allowed values:Days,Items.
UseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Response
201 — Created
ChangeRequestSettingsarray of objectTypeenum
Allowed values:ServiceNow,JiraServiceManagement.
Changesarray of objectBuildInformationarray of objectCommitsarray of object
Aggregate of distinct commits from all VersionMetadata.ReleaseNotesstringVersionstringWorkItemsarray of object
Aggregate of distinct work items from all VersionMetadata.
ChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectStepsarray of object
FailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstringSkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectQuantityToKeepintegerShouldKeepForeverbooleanStrategystringUnitenum
Allowed values:Days,Items.
UseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Request
{
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "string",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "string",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{
"CorrelationId": "string",
"Slug": "string"
}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "string",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "string",
"SkipActions": [
"string"
],
"SpaceId": "string",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "string",
"TenantId": "string",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}Example Response
{
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "string",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "string",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{
"CorrelationId": "string",
"Slug": "string"
}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "string",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "string",
"SkipActions": [
"string"
],
"SpaceId": "string",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "string",
"TenantId": "string",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}Create a new tenanted deployment
POST /api
Also reachable at /api.
Path Parameters
spaceIdstring (required)
Request Body
DebugModestring
Contributes the OctopusPrintVariables and OctopusPrintEvaluatedVariables variables to the execution. One of “None”, “Log” or “Debug”; leave unset for the default of “None”.DeploymentFreezeNamesarray of string
Active deployment freezes to override so this execution can proceed despite them. Overriding a freeze bypasses a deliberate block on deploying, so only set this when explicitly asked to. Requires DeploymentFreezeOverrideReason.DeploymentFreezeOverrideReasonstring
Required, and must not be blank, whenever DeploymentFreezeNames is non-empty. Recorded against the override.EnvironmentNamestring (required)
A single environment. To deploy to several, call the command once per environment.ExcludedMachineNamesarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagNamesarray of string
A collection of deployment target tags (canonical names in format TagSetName/TagName) that should be excluded from the deployment.ForcePackageDownloadboolean
Whether to force downloading of already installed packages (flag, default false).ForcePackageRedeploymentboolean
If a project is configured to skip packages with already-installed versions, override this setting to force re-deployment (flag, default false).NoRunAfterstring
Time at which a scheduled execution should expire if it has not started, specified as any valid DateTimeOffset format, and assuming the time zone is the current local time zone. Only meaningful alongside RunAt. Formatdate-time.Prioritystring
Whether this execution jumps the task queue ahead of other queued tasks. One of “LifecycleDefault” (use the lifecycle’s configured setting), “On” or “Off”.ProjectNamestring (required)ReleaseVersionstring (required)
The version of an existing release, for example “1.2.3” — not a release ID. Minimum length 1.RunAtstring
Time at which the execution should start (scheduling it for later), specified as any valid DateTimeOffset format, and assuming the time zone is the current local time zone. Formatdate-time.SkipStepNamesarray of string
Steps that are to be skipped for this execution. A name that matches no step is logged as a warning rather than failing the command, so check the step name carefully.SpaceIdstring (required)SpaceIdOrNamestring (required)
Both this and SpaceId are required, and normally hold the same space ID; set both.SpecificMachineNamesarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed. A name that matches no machine fails the command.SpecificTargetTagNamesarray of string
A collection of deployment target tags (canonical names in format TagSetName/TagName) that should be included in the deployment.TenantTagsarray of string
Tenant tags, in canonical “TagSetName/TagName” form, selecting the tenants to deploy for. Set this or Tenants — with both empty nothing is deployed and no error is raised.Tenantsarray of string
The tenants to deploy for; one deployment is created per tenant. Set this or TenantTags — with both empty nothing is deployed and no error is raised. The single entry “*” means every tenant that can be deployed to this environment, which may be a very large number — only use it when explicitly asked to deploy to all tenants.UpdateVariableSnapshotboolean
If set to true, the release’s variable set snapshot is updated from the project’s current variables before the deployment. This mutates the release itself, so it affects later deployments of it too — leave it unset unless refreshed variables were asked for.UseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.Variablesobject
Name/value pairs for prompted variables. A prompted variable that is required and has no value supplied here fails the command, naming the variable.
Response
200 — Server tasks associated with the newly-created Deployment
DeploymentServerTasksarray of objectDeploymentIdstringServerTaskIdstring
Example Request
{
"DebugMode": "string",
"DeploymentFreezeNames": [
"string"
],
"DeploymentFreezeOverrideReason": "string",
"EnvironmentName": "string",
"ExcludedMachineNames": [
"string"
],
"ExcludedTargetTagNames": [
"string"
],
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"NoRunAfter": "2020-01-01T00:00:00.000Z",
"Priority": "string",
"ProjectName": "string",
"ReleaseVersion": "string",
"RunAt": "2020-01-01T00:00:00.000Z",
"SkipStepNames": [
"string"
],
"SpaceId": "string",
"SpaceIdOrName": "string",
"SpecificMachineNames": [
"string"
],
"SpecificTargetTagNames": [
"string"
],
"TenantTags": [
"string"
],
"Tenants": [
"string"
],
"UpdateVariableSnapshot": true,
"UseGuidedFailure": true,
"Variables": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
}
}Example Response
{
"DeploymentServerTasks": [
{
"DeploymentId": "string",
"ServerTaskId": "string"
}
]
}Create a new untenanted deployment
POST /api
Also reachable at /api.
Path Parameters
spaceIdstring (required)
Request Body
DebugModestring
Contributes the OctopusPrintVariables and OctopusPrintEvaluatedVariables variables to the execution. One of “None”, “Log” or “Debug”; leave unset for the default of “None”.DeploymentFreezeNamesarray of string
Active deployment freezes to override so this execution can proceed despite them. Overriding a freeze bypasses a deliberate block on deploying, so only set this when explicitly asked to. Requires DeploymentFreezeOverrideReason.DeploymentFreezeOverrideReasonstring
Required, and must not be blank, whenever DeploymentFreezeNames is non-empty. Recorded against the override.EnvironmentNamesarray of string (required)
One deployment is created per environment. Always name at least one: an empty list is not rejected, it simply deploys nothing and returns an empty list of deployments.ExcludedMachineNamesarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagNamesarray of string
A collection of deployment target tags (canonical names in format TagSetName/TagName) that should be excluded from the deployment.ForcePackageDownloadboolean
Whether to force downloading of already installed packages (flag, default false).ForcePackageRedeploymentboolean
If a project is configured to skip packages with already-installed versions, override this setting to force re-deployment (flag, default false).NoRunAfterstring
Time at which a scheduled execution should expire if it has not started, specified as any valid DateTimeOffset format, and assuming the time zone is the current local time zone. Only meaningful alongside RunAt. Formatdate-time.Prioritystring
Whether this execution jumps the task queue ahead of other queued tasks. One of “LifecycleDefault” (use the lifecycle’s configured setting), “On” or “Off”.ProjectNamestring (required)ReleaseVersionstring (required)
The version of an existing release, for example “1.2.3” — not a release ID. Minimum length 1.RunAtstring
Time at which the execution should start (scheduling it for later), specified as any valid DateTimeOffset format, and assuming the time zone is the current local time zone. Formatdate-time.SkipStepNamesarray of string
Steps that are to be skipped for this execution. A name that matches no step is logged as a warning rather than failing the command, so check the step name carefully.SpaceIdstring (required)SpaceIdOrNamestring (required)
Both this and SpaceId are required, and normally hold the same space ID; set both.SpecificMachineNamesarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed. A name that matches no machine fails the command.SpecificTargetTagNamesarray of string
A collection of deployment target tags (canonical names in format TagSetName/TagName) that should be included in the deployment.UpdateVariableSnapshotboolean
If set to true, the release’s variable set snapshot is updated from the project’s current variables before the deployment. This mutates the release itself, so it affects later deployments of it too — leave it unset unless refreshed variables were asked for.UseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.Variablesobject
Name/value pairs for prompted variables. A prompted variable that is required and has no value supplied here fails the command, naming the variable.
Response
200 — Server tasks associated with the newly-created Deployment
DeploymentServerTasksarray of objectDeploymentIdstringServerTaskIdstring
Example Request
{
"DebugMode": "string",
"DeploymentFreezeNames": [
"string"
],
"DeploymentFreezeOverrideReason": "string",
"EnvironmentNames": [
"string"
],
"ExcludedMachineNames": [
"string"
],
"ExcludedTargetTagNames": [
"string"
],
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"NoRunAfter": "2020-01-01T00:00:00.000Z",
"Priority": "string",
"ProjectName": "string",
"ReleaseVersion": "string",
"RunAt": "2020-01-01T00:00:00.000Z",
"SkipStepNames": [
"string"
],
"SpaceId": "string",
"SpaceIdOrName": "string",
"SpecificMachineNames": [
"string"
],
"SpecificTargetTagNames": [
"string"
],
"UpdateVariableSnapshot": true,
"UseGuidedFailure": true,
"Variables": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
}
}Example Response
{
"DeploymentServerTasks": [
{
"DeploymentId": "string",
"ServerTaskId": "string"
}
]
}Create a Deployment
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Request Body
ChangeRequestSettingsarray of objectTypeenum
Allowed values:ServiceNow,JiraServiceManagement.
Changesarray of objectBuildInformationarray of objectCommitsarray of object
Aggregate of distinct commits from all VersionMetadata.ReleaseNotesstringVersionstringWorkItemsarray of object
Aggregate of distinct work items from all VersionMetadata.
ChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstring (required)ExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectStepsarray of object (required)
FailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstring (required)SkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectQuantityToKeepintegerShouldKeepForeverbooleanStrategystringUnitenum
Allowed values:Days,Items.
UseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Response
201 — Created
DeploymentobjectChangeRequestSettingsarray of objectChangesarray of objectChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectFailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstringSkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectUseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Request
{
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "string",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "string",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{
"CorrelationId": "string",
"Slug": "string"
}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "string",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "string",
"SkipActions": [
"string"
],
"SpaceId": "string",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "string",
"TenantId": "string",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}Example Response
{
"Deployment": {
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "string",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "string",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "string",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "string",
"SkipActions": [
"string"
],
"SpaceId": "string",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "string",
"TenantId": "string",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}
}Get a Deployment by ID
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Deployment to load.spaceIdstring (required)
Response
200 — The requested Deployment.
ChangeRequestSettingsarray of objectTypeenum
Allowed values:ServiceNow,JiraServiceManagement.
Changesarray of objectBuildInformationarray of objectCommitsarray of object
Aggregate of distinct commits from all VersionMetadata.ReleaseNotesstringVersionstringWorkItemsarray of object
Aggregate of distinct work items from all VersionMetadata.
ChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectStepsarray of object
FailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstringSkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectQuantityToKeepintegerShouldKeepForeverbooleanStrategystringUnitenum
Allowed values:Days,Items.
UseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Response
{
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "string",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "string",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{
"CorrelationId": "string",
"Slug": "string"
}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "string",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "string",
"SkipActions": [
"string"
],
"SpaceId": "string",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "string",
"TenantId": "string",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}Delete an existing Deployment
DELETE /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Deployment to delete.spaceIdstring (required)
Response
200 — Success